from typing import List, Optional, Dict, Iterable
import aspose.pycore
import aspose.pydrawing
import aspose.html
import aspose.html.accessibility
import aspose.html.accessibility.results
import aspose.html.accessibility.saving
import aspose.html.collections
import aspose.html.converters
import aspose.html.diagnostics
import aspose.html.dom
import aspose.html.dom.attributes
import aspose.html.dom.canvas
import aspose.html.dom.css
import aspose.html.dom.events
import aspose.html.dom.mutations
import aspose.html.dom.svg
import aspose.html.dom.svg.datatypes
import aspose.html.dom.svg.events
import aspose.html.dom.svg.filters
import aspose.html.dom.svg.paths
import aspose.html.dom.svg.saving
import aspose.html.dom.traversal
import aspose.html.dom.traversal.filters
import aspose.html.dom.views
import aspose.html.dom.xpath
import aspose.html.drawing
import aspose.html.forms
import aspose.html.io
import aspose.html.loading
import aspose.html.net
import aspose.html.net.headers
import aspose.html.net.messagefilters
import aspose.html.net.messagehandlers
import aspose.html.rendering
import aspose.html.rendering.doc
import aspose.html.rendering.fonts
import aspose.html.rendering.image
import aspose.html.rendering.pdf
import aspose.html.rendering.pdf.encryption
import aspose.html.rendering.xps
import aspose.html.saving
import aspose.html.saving.resourcehandlers
import aspose.html.services
import aspose.html.toolkit
import aspose.html.toolkit.markdown
import aspose.html.toolkit.markdown.syntax
import aspose.html.toolkit.markdown.syntax.extensions
import aspose.html.toolkit.markdown.syntax.parser
import aspose.html.toolkit.markdown.syntax.parser.extensions
import aspose.html.toolkit.markdown.syntax.parser.extensions.gfm
import aspose.html.toolkit.markdown.syntax.text
import aspose.html.toolkit.optimizers
import aspose.html.window

class AtxHeadingSyntaxNode(LeafBlockSyntaxNode):
    '''Represents the AtxHeadingSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_opening_tag(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken:
        '''Defines the interface for get OpeningTag.
        
        :returns: The MarkdownSyntaxToken.'''
        ...
    
    def get_closing_tag(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken:
        '''Defines the interface for get ClosingTag.
        
        :returns: The closing tag.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class AutoLinkSyntaxNode(InlineSyntaxNode):
    '''Represents the AutoLinkSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_uri(self) -> str:
        '''Get the uri.
        
        :returns: The string value of Content.Span.'''
        ...
    
    def is_mail(self) -> bool:
        '''Get true if is mail.
        
        :returns: The boolean.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class BlockProxy(BlockSyntaxNode):
    '''Represents the BlockProxy.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Defines the interface for Write To writer.
        
        :param writer: The writer.'''
        ...
    
    def get_target(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the target node.
        
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class BlockQuoteSyntaxNode(MultiLineContainerBlockSyntaxNode):
    '''Represents the BlockQuoteSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class BlockSyntaxNode(MarkdownSyntaxNode):
    '''Base implementation of the BlockSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class CharacterReferenceSyntaxNode(InlineSyntaxNode):
    '''Represents the CharacterReferenceSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def source(self) -> aspose.html.toolkit.markdown.syntax.text.SourceText:
        '''Get the source.'''
        ...
    
    @property
    def span(self) -> aspose.html.toolkit.markdown.syntax.text.TextSpan:
        '''Get the span.'''
        ...
    
    @property
    def reference(self) -> str:
        '''Get the reference.'''
        ...
    
    @property
    def value(self) -> str:
        '''Get the value.'''
        ...
    
    ...

class CodeSpanSyntaxNode(InlineContainerSyntaxNode):
    '''Represents the CodeSpanSyntaxNode'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_content(self) -> str:
        '''Defines the interface for get Content.
        
        :returns: The string.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class ContainerBlockSyntaxNode(BlockSyntaxNode):
    '''Base implementation of the ContainerBlockSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class EmphasisSyntaxNode(InlineContainerSyntaxNode):
    '''Represents the EmphasisSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_emphasis_type(self) -> aspose.html.toolkit.markdown.syntax.Emphasis:
        '''Defines the interface for get Emphasis Type
        
        :returns: The Emphasis.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class EmptyLineSyntaxNode(LeafBlockSyntaxNode):
    '''Represents the EmptyLineSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class EscapedCharacterSyntaxNode(TextSyntaxNode):
    '''Implemented the escape character syntax node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The MarkdownSyntaxVisitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def source(self) -> aspose.html.toolkit.markdown.syntax.text.SourceText:
        '''Return the source text.'''
        ...
    
    @property
    def span(self) -> aspose.html.toolkit.markdown.syntax.text.TextSpan:
        '''Defines the interface for get span.'''
        ...
    
    @property
    def value(self) -> str:
        '''Defines the property for get string value.'''
        ...
    
    ...

class FencedCodeBlockSyntaxNode(ContainerBlockSyntaxNode):
    '''Represents the FencedCodeBlockSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_opening_tag(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken:
        '''Defines the interface for get Opening Tag.
        
        :returns: The MarkdownSyntaxToken.'''
        ...
    
    def get_closing_tag(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken:
        '''Defines the interface for get Closing Tag.
        
        :returns: The MarkdownSyntaxToken.'''
        ...
    
    def get_info(self) -> str:
        '''Defines the interface for get Info.
        
        :returns: The string.'''
        ...
    
    def get_content(self) -> str:
        '''Defines the interface for get Content.
        
        :returns: The string.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class HTMLFragmentSyntax(MarkdownSyntaxNode):
    '''Represents the HTMLFragmentSyntax.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_content(self) -> str:
        '''Defines the interface for get Content.
        
        :returns: The string.'''
        ...
    
    def set_content(self, html : str):
        '''Defines the interface for set Content.
        
        :param html: The string html value.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class HardBreakSyntaxNode(LineBreakSyntaxNode):
    '''Represents the HardBreakSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_breaking_tag(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken:
        '''Defines the interface for get Breaking Tag
        
        :returns: The MarkdownSyntaxToken.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def source(self) -> aspose.html.toolkit.markdown.syntax.text.SourceText:
        '''Get the source.'''
        ...
    
    @property
    def span(self) -> aspose.html.toolkit.markdown.syntax.text.TextSpan:
        '''Get the span.'''
        ...
    
    @property
    def value(self) -> str:
        '''Get the value.'''
        ...
    
    ...

class IWritable:
    '''Base interface for IWritable.'''
    
    ...

class IndentedCodeBlockSyntaxNode(ContainerBlockSyntaxNode):
    '''Represents the IndentedCodeBlockSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_content(self) -> str:
        '''Defines the interface for get Content.
        
        :returns: The string.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class InlineContainerSyntaxNode(InlineSyntaxNode):
    '''Represents the InlineContainerSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class InlineImageSyntaxNode(InlineSyntaxNode):
    '''Represents the InlineImageSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_destination(self) -> aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode:
        '''Defines the interface for get destination.
        
        :returns: The LinkDestinationSyntax.'''
        ...
    
    def get_title(self) -> aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode:
        '''Defines the interface for get title.
        
        :returns: The LinkTitleSyntax.'''
        ...
    
    def get_alt_text(self) -> str:
        '''Defines the interface for get all text.
        
        :returns: The string.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class InlineLinkSyntaxNode(InlineSyntaxNode):
    '''Represents the InlineLinkSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_destination(self) -> aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode:
        '''Defines the interface for get destination.
        
        :returns: The LinkDestinationSyntax.'''
        ...
    
    def get_title(self) -> aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode:
        '''Defines the interface for get title.
        
        :returns: The LinkTitleSyntax.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class InlineProxy(InlineSyntaxNode):
    '''Represents InlineProxy.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to text writer.
        
        :param writer: The writer.'''
        ...
    
    def get_target(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get target.
        
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class InlineSyntaxNode(MarkdownSyntaxNode):
    '''Base implementation of the InlineSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class LeafBlockSyntaxNode(BlockSyntaxNode):
    '''Base implementation of the LeafBlockSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class LineBreakSyntaxNode(InlineSyntaxNode):
    '''Represent the LineBreakSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def source(self) -> aspose.html.toolkit.markdown.syntax.text.SourceText:
        '''Get the source.'''
        ...
    
    @property
    def span(self) -> aspose.html.toolkit.markdown.syntax.text.TextSpan:
        '''Get the span.'''
        ...
    
    @property
    def value(self) -> str:
        '''Get the value.'''
        ...
    
    ...

class LinkDestinationSyntaxNode(InlineContainerSyntaxNode):
    '''Represent the LinkDestinationSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_value(self) -> str:
        '''Defines the interface for get string value.
        
        :returns: The string.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class LinkReferenceDefinitionSyntaxNode(LeafBlockSyntaxNode):
    '''Represent the LinkReferenceDefinitionSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_label(self) -> aspose.html.toolkit.markdown.syntax.TextSyntaxNode:
        '''Returns the link reference label.
        
        :returns: The :py:class:`aspose.html.toolkit.markdown.syntax.TextSyntaxNode` object.'''
        ...
    
    def set_label(self, label : aspose.html.toolkit.markdown.syntax.TextSyntaxNode):
        '''Sets the link reference label.
        
        :param label: The :py:class:`aspose.html.toolkit.markdown.syntax.TextSyntaxNode` object.'''
        ...
    
    def get_destination(self) -> aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode:
        '''Returns the link reference destination.
        
        :returns: The :py:class:`aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode` object.'''
        ...
    
    def set_destination(self, destination : aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode):
        '''Sets the link reference destination.
        
        :param destination: The :py:class:`aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode` object.'''
        ...
    
    def get_title(self) -> aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode:
        '''Returns the link reference title.
        
        :returns: The :py:class:`aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode` object.'''
        ...
    
    def set_title(self, title : aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode):
        '''Sets the link reference title.
        
        :param title: The :py:class:`aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode` object.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class LinkTitleSyntaxNode(InlineContainerSyntaxNode):
    '''Represent the LinkTitleSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_value(self) -> str:
        '''Defines the interface for get string value.
        
        :returns: The string.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class ListItemMarker(MarkdownSyntaxNode):
    '''Base implementation of the ListItemMarker.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Accept the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class ListItemSyntaxNode(MultiLineContainerBlockSyntaxNode):
    '''Represent the ListItemSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def is_tight(self) -> bool:
        '''Get true if is tight.
        
        :returns: the boolean.'''
        ...
    
    def get_marker(self) -> aspose.html.toolkit.markdown.syntax.ListItemMarker:
        '''Get marker
        
        :returns: The ListItemMarker.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class ListSyntaxNode(ContainerBlockSyntaxNode):
    '''Base implementation of the ListSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def is_tight(self) -> bool:
        '''Defines the interface for get is tight.
        
        :returns: The boolean value.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class MarkdownException:
    '''The Markdown exception'''
    
    ...

class MarkdownSyntaxFactory:
    '''Factory used to create various :py:class:`aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode` descendants.'''
    
    @overload
    def atx_heading(self, text : str) -> aspose.html.toolkit.markdown.syntax.AtxHeadingSyntaxNode:
        '''Creates AtxHeadingSyntaxNode with text content.
        
        :param text: The heading text content.
        :returns: The AtxHeadingSyntax.'''
        ...
    
    @overload
    def atx_heading(self, text : str, level : int) -> aspose.html.toolkit.markdown.syntax.AtxHeadingSyntaxNode:
        '''Creates AtxHeadingSyntaxNode with text content and heading level.
        
        :param text: The heading text content.
        :param level: The heading level value.
        :returns: The AtxHeadingSyntax.'''
        ...
    
    @overload
    def atx_heading(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.AtxHeadingSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.AtxHeadingSyntaxNode`.
        
        :param opening: The opening token.
        :param closing: The closing token.
        :returns: The AtxHeadingSyntax.'''
        ...
    
    @overload
    def html_fragment(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.HTMLFragmentSyntax:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.HTMLFragmentSyntax`.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The  HTMLFragmentSyntax.'''
        ...
    
    @overload
    def html_fragment(self) -> aspose.html.toolkit.markdown.syntax.HTMLFragmentSyntax:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.HTMLFragmentSyntax`.
        
        :returns: The HTMLFragmentSyntax.'''
        ...
    
    @overload
    def auto_link(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, content : aspose.html.toolkit.markdown.syntax.TextSyntaxNode, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.AutoLinkSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.AutoLinkSyntaxNode`.
        
        :param opening: The MarkdownSyntaxToken.
        :param content: The TextSyntax.
        :param closing: The MarkdownSyntaxToken.
        :returns: The AutoLinkSyntax.'''
        ...
    
    @overload
    def auto_link(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, content : aspose.html.toolkit.markdown.syntax.TextSyntaxNode, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, mail : bool) -> aspose.html.toolkit.markdown.syntax.AutoLinkSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.AutoLinkSyntaxNode`.
        
        :param opening: The MarkdownSyntaxToken.
        :param content: The TextSyntax.
        :param closing: The MarkdownSyntaxToken.
        :param mail: The boolean flag.
        :returns: The AutoLinkSyntax.'''
        ...
    
    @overload
    def token(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken`.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The MarkdownSyntaxToken.'''
        ...
    
    @overload
    def token(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken`.
        
        :param source: The SourceText.
        :returns: The MarkdownSyntaxToken.'''
        ...
    
    @overload
    def text(self, text : str) -> aspose.html.toolkit.markdown.syntax.TextSyntaxNode:
        '''Creates TextSyntax
        
        :param text: The string value.
        :returns: The TextSyntax.'''
        ...
    
    @overload
    def text(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText) -> aspose.html.toolkit.markdown.syntax.TextSyntaxNode:
        '''Create the TextSyntax from SourceText.
        
        :param source: The SourceText.
        :returns: The TextSyntax.'''
        ...
    
    @overload
    def text(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.TextSyntaxNode:
        '''Create the TextSyntax from SourceText and TextSpan.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The TextSyntax.'''
        ...
    
    @overload
    def escaped_character(self, escaped_char : char) -> aspose.html.toolkit.markdown.syntax.TextSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.TextSyntaxNode`.
        
        :param escaped_char: The escapedChar.
        :returns: The TextSyntax.'''
        ...
    
    @overload
    def escaped_character(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.TextSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.TextSyntaxNode`.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The TextSyntax.'''
        ...
    
    @overload
    def whitespace(self) -> aspose.html.toolkit.markdown.syntax.WhitespaceSyntaxNode:
        '''Create the WhitespaceSyntax.
        
        :returns: The WhitespaceSyntax.'''
        ...
    
    @overload
    def whitespace(self, count : int) -> aspose.html.toolkit.markdown.syntax.WhitespaceSyntaxNode:
        '''Create the WhitespaceSyntax.
        
        :param count: The count of white space.
        :returns: The WhitespaceSyntax.'''
        ...
    
    @overload
    def whitespace(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText) -> aspose.html.toolkit.markdown.syntax.WhitespaceSyntaxNode:
        '''Create the WhitespaceSyntax.
        
        :param source: The SourceText.
        :returns: The WhitespaceSyntax.'''
        ...
    
    @overload
    def whitespace(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.WhitespaceSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.WhitespaceSyntaxNode`.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The WhitespaceSyntax.'''
        ...
    
    @overload
    def code_span(self, backticks_count : int) -> aspose.html.toolkit.markdown.syntax.CodeSpanSyntaxNode:
        '''Creates the :py:class:`aspose.html.toolkit.markdown.syntax.CodeSpanSyntaxNode` with the specified number of backticks.
        
        :param backticks_count: Number of backticks.
        :returns: The CodeSpanSyntax.'''
        ...
    
    @overload
    def code_span(self) -> aspose.html.toolkit.markdown.syntax.CodeSpanSyntaxNode:
        '''Creates the :py:class:`aspose.html.toolkit.markdown.syntax.CodeSpanSyntaxNode`.
        
        :returns: The CodeSpanSyntax.'''
        ...
    
    @overload
    def code_span(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.CodeSpanSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.CodeSpanSyntaxNode`.
        
        :param opening: The opening token.
        :param closing: The closing token.
        :returns: The CodeSpanSyntax.'''
        ...
    
    @overload
    def link_title(self) -> aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode`.
        
        :returns: The :py:class:`aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode` object.'''
        ...
    
    @overload
    def link_title(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode`.
        
        :param opening: The opening token.
        :param closing: The closing token.
        :returns: The :py:class:`aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode` object.'''
        ...
    
    @overload
    def link_title(self, title : str) -> aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode:
        '''Creates LinkTitleSyntaxNode object from a string.
        
        :param title: Title string.
        :returns: The :py:class:`aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode` object.'''
        ...
    
    @overload
    def link_destination(self) -> aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode`.
        
        :returns: The :py:class:`aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode` object .'''
        ...
    
    @overload
    def link_destination(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode`.
        
        :param opening: The opening token.
        :param closing: The closing token.
        :returns: The :py:class:`aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode` object .'''
        ...
    
    @overload
    def link_destination(self, url : str) -> aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode:
        '''Creates LinkDestinationSyntaxNode object from a string.
        
        :param url: Destination URL string.
        :returns: The :py:class:`aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode` object .'''
        ...
    
    @overload
    def fenced_code_block(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, info : aspose.html.toolkit.markdown.syntax.TextSyntaxNode) -> aspose.html.toolkit.markdown.syntax.FencedCodeBlockSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.FencedCodeBlockSyntaxNode`.
        
        :param opening: The opening token.
        :param info: The TextSyntax.
        :returns: The FencedCodeBlockSyntax.'''
        ...
    
    @overload
    def fenced_code_block(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, info : aspose.html.toolkit.markdown.syntax.TextSyntaxNode, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.FencedCodeBlockSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.FencedCodeBlockSyntaxNode`.
        
        :param opening: The opening token.
        :param info: The TextSyntax.
        :param closing: The closing token.
        :returns: The FencedCodeBlockSyntax.'''
        ...
    
    @overload
    def emphasis(self, emphasis : aspose.html.toolkit.markdown.syntax.Emphasis) -> aspose.html.toolkit.markdown.syntax.EmphasisSyntaxNode:
        '''Create the EmphasisSyntax.
        
        :param emphasis: The emphasis.
        :returns: The EmphasisSyntax.'''
        ...
    
    @overload
    def emphasis(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.EmphasisSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.EmphasisSyntaxNode`.
        
        :param opening: The opening token.
        :param closing: The closing token.
        :returns: The EmphasisSyntax.'''
        ...
    
    @overload
    def indented_code(self) -> aspose.html.toolkit.markdown.syntax.IndentedCodeBlockSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.IndentedCodeBlockSyntaxNode`.
        
        :returns: The IndentedCodeBlockSyntax.'''
        ...
    
    @overload
    def indented_code(self, reserved_spaces : int) -> aspose.html.toolkit.markdown.syntax.IndentedCodeBlockSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.IndentedCodeBlockSyntaxNode`.
        
        :param reserved_spaces: The reservedSpaces.
        :returns: The IndentedCodeBlockSyntax.'''
        ...
    
    @overload
    def inline_image(self, alt_text : str, href : str, title : str) -> aspose.html.toolkit.markdown.syntax.InlineImageSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.InlineImageSyntaxNode`.
        
        :param alt_text: The alternative text.
        :param href: The URL of image.
        :param title: The title.
        :returns: The InlineImageSyntax.'''
        ...
    
    @overload
    def inline_image(self, content_opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, content_closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, declaration_opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, destination : aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode, title : aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode, declaration_closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.InlineImageSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.InlineImageSyntaxNode`.
        
        :param content_opening: The contentOpening.
        :param content_closing: The contentClosing.
        :param declaration_opening: The declarationOpening.
        :param destination: The destination.
        :param title: The title.
        :param declaration_closing: The declarationClosing.
        :returns: The InlineImageSyntax.'''
        ...
    
    @overload
    def inline_link(self, content_opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, content_closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, declaration_opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, destination : aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode, title : aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode, declaration_closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.InlineLinkSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.InlineLinkSyntaxNode`.
        
        :param content_opening: The contentOpening.
        :param content_closing: The contentClosing.
        :param declaration_opening: The declarationOpening.
        :param destination: The destination.
        :param title: The title.
        :param declaration_closing: The declarationClosing.
        :returns: The InlineLinkSyntax.'''
        ...
    
    @overload
    def inline_link(self, text : str, destination : str, title : str) -> aspose.html.toolkit.markdown.syntax.InlineLinkSyntaxNode:
        '''Creates InlineLink.
        
        :param text: The link text.
        :param destination: The string destination.
        :param title: The string title.
        :returns: The LinkReferenceDefinitionSyntax.'''
        ...
    
    @overload
    def list_item_marker(self, number : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, delimiter : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.ListItemMarker:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.ListItemMarker`.
        
        :param number: The number.
        :param delimiter: The delimiter.
        :returns: The ListItemMarker.'''
        ...
    
    @overload
    def list_item_marker(self, token : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.ListItemMarker:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.ListItemMarker`.
        
        :param token: The token.
        :returns: The ListItemMarker.'''
        ...
    
    def inline_proxy(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.InlineProxy:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.InlineProxy`.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The InlineProxy.'''
        ...
    
    def block_proxy(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.BlockProxy:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.BlockProxy`.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The InlineProxy.'''
        ...
    
    def hugo_yaml_based_front_matter(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, text : aspose.html.toolkit.markdown.syntax.TextSyntaxNode, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.extensions.HugoYamlBasedFrontMatterSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.extensions.HugoYamlBasedFrontMatterSyntaxNode`.
        
        :param opening: The opening MarkdownSyntaxToken.
        :param text: The TextSyntax.
        :param closing: The closing MarkdownSyntaxToken.
        :returns: The HugoYamlBasedFrontMatterSyntax.'''
        ...
    
    def hugo_short_code(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, closing_mark : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.extensions.HugoShortCodeSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.extensions.HugoShortCodeSyntaxNode`.
        
        :param opening: The opening MarkdownSyntaxToken.
        :param closing_mark: The closing mark MarkdownSyntaxToken.
        :param closing: The closing MarkdownSyntaxToken.
        :returns: The HugoShortCodeSyntax.'''
        ...
    
    def hugo_short_code_parameter(self, name : aspose.html.toolkit.markdown.syntax.TextSyntaxNode, equal_sign : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, quotation_open : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, value : aspose.html.toolkit.markdown.syntax.TextSyntaxNode, quotation_close : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.extensions.ShortCodeParameterSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.extensions.ShortCodeParameterSyntaxNode`.
        
        :param name: The TextSyntax.
        :param equal_sign: The equal sign.
        :param quotation_open: The quotationOpen.
        :param value: The TextSyntax value.
        :param quotation_close: The quotationClose.
        :returns: The ShortCodeParameterSyntax.'''
        ...
    
    def empty_line(self) -> aspose.html.toolkit.markdown.syntax.EmptyLineSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.EmptyLineSyntaxNode`.
        
        :returns: The EmptyLineSyntax.'''
        ...
    
    def reference_link(self, content_opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, content : aspose.html.toolkit.markdown.syntax.InlineContainerSyntaxNode, content_closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, label_opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, label : aspose.html.toolkit.markdown.syntax.InlineContainerSyntaxNode, label_closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.ReferenceLinkSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.ReferenceLinkSyntaxNode`.
        
        :param content_opening: The contentOpening.
        :param content: The InlineContainerSyntax.
        :param content_closing: The contentClosing.
        :param label_opening: The labelOpening.
        :param label: The InlineContainerSyntax.
        :param label_closing: The labelClosing.
        :returns: The ReferenceLinkSyntax.'''
        ...
    
    def inline_container(self) -> aspose.html.toolkit.markdown.syntax.InlineContainerSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.InlineContainerSyntaxNode`.
        
        :returns: The InlineContainerSyntax.'''
        ...
    
    def link_label(self, label : str) -> aspose.html.toolkit.markdown.syntax.TextSyntaxNode:
        '''Creates link label from a string.
        
        :param label: Label string.
        :returns: The :py:class:`aspose.html.toolkit.markdown.syntax.TextSyntaxNode` object.'''
        ...
    
    def emphasis_opening(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken:
        '''Create the MarkdownSyntaxToken.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The MarkdownSyntaxToken.'''
        ...
    
    def emphasis_closing(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken:
        '''Create EmphasisClosing.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The MarkdownSyntaxToken.'''
        ...
    
    def hard_breaking_tag(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken:
        '''Create HardBreakingTag.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The MarkdownSyntaxToken.'''
        ...
    
    def reference_image(self, content_opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, content_closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, label_opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, label : aspose.html.toolkit.markdown.syntax.InlineContainerSyntaxNode, label_closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.ReferenceImageSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.ReferenceImageSyntaxNode`.
        
        :param content_opening: The contentOpening.
        :param content_closing: The contentClosing.
        :param label_opening: The labelOpening.
        :param label: The label.
        :param label_closing: The labelClosing.
        :returns: The ReferenceImageSyntax.'''
        ...
    
    def block_quote(self) -> aspose.html.toolkit.markdown.syntax.BlockQuoteSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.BlockQuoteSyntaxNode`.
        
        :returns: The BlockQuoteSyntax.'''
        ...
    
    def link_reference_definition(self, label_opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, label : aspose.html.toolkit.markdown.syntax.TextSyntaxNode, label_closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, destination : aspose.html.toolkit.markdown.syntax.LinkDestinationSyntaxNode, title : aspose.html.toolkit.markdown.syntax.LinkTitleSyntaxNode) -> aspose.html.toolkit.markdown.syntax.LinkReferenceDefinitionSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.LinkReferenceDefinitionSyntaxNode`.
        
        :param label_opening: The labelOpening.
        :param label: The label.
        :param label_closing: The labelClosing.
        :param destination: The destination.
        :param title: The title.
        :returns: The LinkReferenceDefinitionSyntax.'''
        ...
    
    def paragraph(self) -> aspose.html.toolkit.markdown.syntax.ParagraphSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.ParagraphSyntaxNode`.
        
        :returns: The ParagraphSyntax.'''
        ...
    
    def setext_heading(self, tag : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.SetextHeadingSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.SetextHeadingSyntaxNode`.
        
        :param tag: The MarkdownSyntaxToken.
        :returns: The SetextHeadingSyntax.'''
        ...
    
    def ordered_list(self) -> aspose.html.toolkit.markdown.syntax.OrderedListSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.OrderedListSyntaxNode`.
        
        :returns: The OrderedListSyntax.'''
        ...
    
    def table_cell(self) -> aspose.html.toolkit.markdown.syntax.TableCellSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.TableCellSyntaxNode`.
        
        :returns: The TableCellSyntax.'''
        ...
    
    def table_delimiter(self, delimiter : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.TableDelimiterSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.TableDelimiterSyntaxNode`.
        
        :param delimiter: The delimiter.
        :returns: The TableDelimiterSyntax.'''
        ...
    
    def table_row(self) -> aspose.html.toolkit.markdown.syntax.TableRowSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.TableRowSyntaxNode`.
        
        :returns: The TableRowSyntax.'''
        ...
    
    def list_item(self, marker : aspose.html.toolkit.markdown.syntax.ListItemMarker) -> aspose.html.toolkit.markdown.syntax.ListItemSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.ListItemSyntaxNode`.
        
        :param marker: The marker.
        :returns: The ListItemSyntax.'''
        ...
    
    def unordered_list_item(self, marker : str) -> aspose.html.toolkit.markdown.syntax.ListItemSyntaxNode:
        '''Creates a new instance of the :py:class:`aspose.html.toolkit.markdown.syntax.ListItemSyntaxNode` class with unordered list item marker.
        
        :param marker: The unordered list item marker.
        :returns: Created :py:class:`aspose.html.toolkit.markdown.syntax.ListItemSyntaxNode`.'''
        ...
    
    def ordered_list_item(self, number : int) -> aspose.html.toolkit.markdown.syntax.ListItemSyntaxNode:
        '''Creates a new instance of the :py:class:`aspose.html.toolkit.markdown.syntax.ListItemSyntaxNode` class with ordered list item marker.
        
        :param number: The number which will be used to create ordered list item marker.
        :returns: Created :py:class:`aspose.html.toolkit.markdown.syntax.ListItemSyntaxNode`.'''
        ...
    
    def unordered_list(self) -> aspose.html.toolkit.markdown.syntax.UnorderedListSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.UnorderedListSyntaxNode`.
        
        :returns: The UnorderedListSyntax.'''
        ...
    
    def soft_break(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.SoftBreakSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.SoftBreakSyntaxNode`.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The SoftBreakSyntax.'''
        ...
    
    def table(self) -> aspose.html.toolkit.markdown.syntax.TableSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.TableSyntaxNode`.
        
        :returns: The TableSyntax.'''
        ...
    
    def thematic_break(self, tag : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.ThematicBreakSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.ThematicBreakSyntaxNode`.
        
        :param tag: The MarkdownSyntaxToken.
        :returns: The ThematicBreakSyntax.'''
        ...
    
    def hard_break(self, tag : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.HardBreakSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.HardBreakSyntaxNode`.
        
        :param tag: The MarkdownSyntaxToken.
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The HardBreakSyntax.'''
        ...
    
    def character_reference(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan, value : str) -> aspose.html.toolkit.markdown.syntax.CharacterReferenceSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.WhitespaceSyntaxNode`.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :param value: The string value.
        :returns: The CharacterReferenceSyntax.'''
        ...
    
    def trivia(self, source : aspose.html.toolkit.markdown.syntax.text.SourceText, span : aspose.html.toolkit.markdown.syntax.text.TextSpan) -> aspose.html.toolkit.markdown.syntax.WhitespaceSyntaxNode:
        '''Creates Whitespace.
        
        :param source: The SourceText.
        :param span: The TextSpan.
        :returns: The WhitespaceSyntax.'''
        ...
    
    def new_line_trivia(self) -> aspose.html.toolkit.markdown.syntax.WhitespaceSyntaxNode:
        '''Creates NewLineTrivia.
        
        :returns: The WhitespaceSyntax.'''
        ...
    
    def task_list_item_marker(self, opening : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, label : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken, closing : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxToken) -> aspose.html.toolkit.markdown.syntax.TaskListItemMarker:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.TaskListItemMarker`.
        
        :param opening: The opening.
        :param label: The label.
        :param closing: The closing.
        :returns: The TaskListItemMarker.'''
        ...
    
    def task_list_item(self, marker : aspose.html.toolkit.markdown.syntax.ListItemMarker, task_item_marker : aspose.html.toolkit.markdown.syntax.TaskListItemMarker) -> aspose.html.toolkit.markdown.syntax.TaskListItemSyntaxNode:
        '''Creates :py:class:`aspose.html.toolkit.markdown.syntax.TaskListItemSyntaxNode`.
        
        :param marker: The marker.
        :param task_item_marker: The taskItemMarker.
        :returns: The TaskListItemSyntax.'''
        ...
    
    ...

class MarkdownSyntaxNode(IWritable):
    '''Base implementation of the MarkdownSyntaxNode.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Accept the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class MarkdownSyntaxNodeFilter:
    '''Base implementation of the MarkdownSyntaxNodeFilter.'''
    
    def accept_node(self, n : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> int:
        '''Defines the interface for accepting node.
        
        :param n: The MarkdownSyntaxNode.
        :returns: The short value.'''
        ...
    
    @classmethod
    @property
    def FILTER_ACCEPT(cls) -> int:
        '''The filter accept constant.'''
        ...
    
    @classmethod
    @property
    def FILTER_REJECT(cls) -> int:
        '''The filter reject constant.'''
        ...
    
    @classmethod
    @property
    def FILTER_SKIP(cls) -> int:
        '''The filter skip constant.'''
        ...
    
    @classmethod
    @property
    def ANY(cls) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNodeFilter:
        '''The AnyMarkdownSyntaxNodeFilter.'''
        ...
    
    ...

class MarkdownSyntaxToken(MarkdownSyntaxNode):
    '''Represent the Markdown Syntax Token.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Accept the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_full_text(self) -> str:
        '''Defines the interface for get the full text.
        
        :returns: The string.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def span(self) -> aspose.html.toolkit.markdown.syntax.text.TextSpan:
        '''Get the span.'''
        ...
    
    @property
    def source(self) -> aspose.html.toolkit.markdown.syntax.text.SourceText:
        '''Get the source text.'''
        ...
    
    @property
    def text(self) -> str:
        '''Get the text content of span.'''
        ...
    
    ...

class MarkdownSyntaxTree(MarkdownSyntaxNode):
    '''Represent the Markdown Syntax Tree.'''
    
    @overload
    def save(self, path : str):
        '''Saves the syntax tree to the specified path.
        
        :param path: The string path.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase):
        '''Saves the syntax tree to the specified stream.
        
        :param stream: The stream.'''
        ...
    
    @overload
    def create_node_iterator(self, filter : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNodeFilter) -> aspose.html.toolkit.markdown.syntax.NodeIterator:
        '''Defines the interface for create of the node iterator.
        
        :param filter: The filter.
        :returns: The node iterator.'''
        ...
    
    @overload
    def create_node_iterator(self, root : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.NodeIterator:
        '''Defines the interface for create of the node iterator.
        
        :param root: The MarkdownSyntaxNode.
        :returns: The node iterator.'''
        ...
    
    @overload
    def create_node_iterator(self, root : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, filter : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNodeFilter) -> aspose.html.toolkit.markdown.syntax.NodeIterator:
        '''Defines the interface for create of the node iterator.
        
        :param root: The MarkdownSyntaxNode.
        :param filter: The MarkdownSyntaxNodeFilter.
        :returns: The node iterator.'''
        ...
    
    @overload
    def create_tree_walker(self, filter : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNodeFilter) -> aspose.html.toolkit.markdown.syntax.TreeWalker:
        '''Defines the interface for create the tree walker.
        
        :param filter: The MarkdownSyntaxNodeFilter.
        :returns: The tree walker.'''
        ...
    
    @overload
    def create_tree_walker(self, root : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.TreeWalker:
        '''Defines the interface for create the tree walker.
        
        :param root: The MarkdownSyntaxNode.
        :returns: The tree walker.'''
        ...
    
    @overload
    def create_tree_walker(self, root : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, filter : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNodeFilter) -> aspose.html.toolkit.markdown.syntax.TreeWalker:
        '''Defines the interface for create the tree walker.
        
        :param root: The MarkdownSyntaxNode.
        :param filter: The MarkdownSyntaxNodeFilter.
        :returns: The tree walker.'''
        ...
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for visiting nodes of the syntax tree.
        
        :param visitor: The MarkdownSyntaxVisitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def syntax_factory(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxFactory:
        ...
    
    ...

class MarkdownSyntaxVisitor:
    '''The base class for markdown syntax visitor.'''
    
    @overload
    def visit(self, syntax_tree : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree):
        '''Defines the interface for visit syntax tree.
        
        :param syntax_tree: The syntax tree.'''
        ...
    
    @overload
    def visit(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode):
        '''Defines the interface for visit node.
        
        :param node: The MarkdownSyntaxNode.'''
        ...
    
    @overload
    def visit_line_break(self, line_break : aspose.html.toolkit.markdown.syntax.SoftBreakSyntaxNode):
        '''Defines the interface for visit SoftBreakSyntax.
        
        :param line_break: The SoftBreakSyntax.'''
        ...
    
    @overload
    def visit_line_break(self, line_break : aspose.html.toolkit.markdown.syntax.HardBreakSyntaxNode):
        '''Defines the interface for visit HardBreakSyntax.
        
        :param line_break: The HardBreakSyntax.'''
        ...
    
    @overload
    def visit_list(self, list : aspose.html.toolkit.markdown.syntax.UnorderedListSyntaxNode):
        '''Defines the interface for visit UnorderedListSyntax.
        
        :param list: The UnorderedListSyntax.'''
        ...
    
    @overload
    def visit_list(self, list : aspose.html.toolkit.markdown.syntax.OrderedListSyntaxNode):
        '''Defines the interface for visit OrderedListSyntax.
        
        :param list: The OrderedListSyntax.'''
        ...
    
    @overload
    def visit_link(self, link : aspose.html.toolkit.markdown.syntax.InlineLinkSyntaxNode):
        '''Defines the interface for visit InlineLinkSyntax.
        
        :param link: The InlineLinkSyntax.'''
        ...
    
    @overload
    def visit_link(self, link : aspose.html.toolkit.markdown.syntax.AutoLinkSyntaxNode):
        '''Defines the interface for visit AutoLinkSyntax.
        
        :param link: The AutoLinkSyntax.'''
        ...
    
    def visit_block(self, block : aspose.html.toolkit.markdown.syntax.BlockSyntaxNode):
        '''Defines the interface for visit block.
        
        :param block: The block.'''
        ...
    
    def visit_empty_line(self, text_line : aspose.html.toolkit.markdown.syntax.EmptyLineSyntaxNode):
        '''Defines the interface for visit text line.
        
        :param text_line: The text line.'''
        ...
    
    def visit_text(self, text : aspose.html.toolkit.markdown.syntax.TextSyntaxNode):
        '''Defines the interface for visit text syntax.
        
        :param text: The text syntax.'''
        ...
    
    def visit_escaped_character(self, character : aspose.html.toolkit.markdown.syntax.EscapedCharacterSyntaxNode):
        '''Defines the interface for visit escape character.
        
        :param character: The escape character.'''
        ...
    
    def visit_whitespace(self, whitespace : aspose.html.toolkit.markdown.syntax.WhitespaceSyntaxNode):
        '''Defines the interface for visit Whitespace Syntax.
        
        :param whitespace: The whitespace.'''
        ...
    
    def visit_syntax_node(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode):
        '''Defines the interface for visit node.
        
        :param node: The MarkdownSyntaxNode.'''
        ...
    
    def visit_syntax_tree(self, tree : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree):
        '''Defines the interface for visit MarkdownSyntaxTree.
        
        :param tree: The MarkdownSyntaxTree.'''
        ...
    
    def visit_paragraph(self, paragraph : aspose.html.toolkit.markdown.syntax.ParagraphSyntaxNode):
        '''Defines the interface for visit paragraph.
        
        :param paragraph: The paragraph.'''
        ...
    
    def visit_atx_heading(self, heading : aspose.html.toolkit.markdown.syntax.AtxHeadingSyntaxNode):
        '''Defines the interface for visit AtxHeadingSyntax.
        
        :param heading: The AtxHeadingSyntax.'''
        ...
    
    def visit_setext_heading(self, heading : aspose.html.toolkit.markdown.syntax.SetextHeadingSyntaxNode):
        '''Defines the interface for visit SetextHeadingSyntax.
        
        :param heading: The SetextHeadingSyntax.'''
        ...
    
    def visit_thematic_break(self, heading : aspose.html.toolkit.markdown.syntax.ThematicBreakSyntaxNode):
        '''Defines the interface for visit ThematicBreakSyntax.
        
        :param heading: The ThematicBreakSyntax.'''
        ...
    
    def visit_emphasis(self, emphasis : aspose.html.toolkit.markdown.syntax.EmphasisSyntaxNode):
        '''Defines the interface for visit EmphasisSyntax.
        
        :param emphasis: The EmphasisSyntax.'''
        ...
    
    def visit_code_span(self, code_span : aspose.html.toolkit.markdown.syntax.CodeSpanSyntaxNode):
        '''Defines the interface for visit CodeSpanSyntax.
        
        :param code_span: The  CodeSpanSyntax.'''
        ...
    
    def visit_character_reference(self, character_reference : aspose.html.toolkit.markdown.syntax.CharacterReferenceSyntaxNode):
        '''Defines the interface for visit CharacterReferenceSyntax.
        
        :param character_reference: The CharacterReferenceSyntax.'''
        ...
    
    def visit_list_item(self, list_item : aspose.html.toolkit.markdown.syntax.ListItemSyntaxNode):
        '''Defines the interface for visit ListItemSyntax.
        
        :param list_item: The ListItemSyntax.'''
        ...
    
    def visit_block_quote(self, block_quote : aspose.html.toolkit.markdown.syntax.BlockQuoteSyntaxNode):
        '''Defines the interface for visit BlockQuoteSyntax.
        
        :param block_quote: The BlockQuoteSyntax.'''
        ...
    
    def visit_indented_code_block(self, code_block : aspose.html.toolkit.markdown.syntax.IndentedCodeBlockSyntaxNode):
        '''Defines the interface for visit IndentedCodeBlockSyntax.
        
        :param code_block: The IndentedCodeBlockSyntax.'''
        ...
    
    def visit_fenced_code_block(self, code_block : aspose.html.toolkit.markdown.syntax.FencedCodeBlockSyntaxNode):
        '''Defines the interface for visit FencedCodeBlockSyntax.
        
        :param code_block: The FencedCodeBlockSyntax.'''
        ...
    
    def visit_table(self, table : aspose.html.toolkit.markdown.syntax.TableSyntaxNode):
        '''Defines the interface for visit TableSyntax.
        
        :param table: The TableSyntax.'''
        ...
    
    def visit_reference_link(self, link : aspose.html.toolkit.markdown.syntax.ReferenceLinkSyntaxNode):
        '''Defines the interface for visit ReferenceLinkSyntax.
        
        :param link: The ReferenceLinkSyntax.'''
        ...
    
    def visit_image(self, image : aspose.html.toolkit.markdown.syntax.InlineImageSyntaxNode):
        '''Defines the interface for visit InlineImageSyntax.
        
        :param image: The InlineImageSyntax.'''
        ...
    
    def visit_reference_image(self, image : aspose.html.toolkit.markdown.syntax.ReferenceImageSyntaxNode):
        '''Defines the interface for visit ReferenceImageSyntax.
        
        :param image: The ReferenceImageSyntax.'''
        ...
    
    def visit_link_reference_definition(self, definition : aspose.html.toolkit.markdown.syntax.LinkReferenceDefinitionSyntaxNode):
        '''Defines the interface for visit LinkReferenceDefinitionSyntax.
        
        :param definition: The LinkReferenceDefinitionSyntax.'''
        ...
    
    def visit_html(self, html : aspose.html.toolkit.markdown.syntax.HTMLFragmentSyntax):
        '''Defines the interface for visit HTMLFragmentSyntax.
        
        :param html: The HTMLFragmentSyntax.'''
        ...
    
    def visit_node_list(self, list : aspose.html.collections.NodeList):
        '''Defines the interface for visit NodeList.
        
        :param list: The NodeList.'''
        ...
    
    ...

class MarkdownTextWriter:
    '''Represent the Markdown text writer'''
    
    ...

class MultiLineContainerBlockSyntaxNode(ContainerBlockSyntaxNode):
    '''Base implementation of an MultiLine Container Block Syntax Node'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class NodeIterator(Traversal):
    '''The nodes iterator.'''
    
    def next_node(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get the next node.
        
        :returns: The markdown syntax node.'''
        ...
    
    def previous_node(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get the previous node.
        
        :returns: The markdown syntax node.'''
        ...
    
    def detach(self):
        '''The detach() method, when invoked, must do nothing'''
        ...
    
    @property
    def root(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get Root node.'''
        ...
    
    @property
    def filter(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNodeFilter:
        '''Defines the interface for get Filter.'''
        ...
    
    @property
    def reference_node(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def pointer_before_reference_node(self) -> bool:
        ...
    
    ...

class NodeList(IWritable):
    '''Base implementation of the NodeList.'''
    
    def get(self, index : int) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def count(self) -> int:
        ...
    
    ...

class OrderedListItemMarker(ListItemMarker):
    '''Represent the ordered list item marker.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Accept the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_index(self) -> int:
        '''Defines the interface for get of the get index.
        
        :returns: The index.'''
        ...
    
    def get_delimiter(self) -> str:
        '''Defines the interface for get of the delimiter.
        
        :returns: The string delimiter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class OrderedListSyntaxNode(ListSyntaxNode):
    '''Represent the Ordered list syntax.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept of the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def is_tight(self) -> bool:
        '''Defines the interface for get is tight.
        
        :returns: The boolean value.'''
        ...
    
    def get_start(self) -> int:
        '''Defines the interface for get the start index.
        
        :returns: The index.'''
        ...
    
    def get_delimiter(self) -> str:
        '''Defines the interface for get of the delimiter.
        
        :returns: The string delimiter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class ParagraphSyntaxNode(LeafBlockSyntaxNode):
    '''Represent the paragraph syntax node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept of the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_content(self) -> aspose.html.collections.NodeList:
        '''Defines the interface for get content.
        
        :returns: The InlineContainer syntax.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class ReferenceImageSyntaxNode(InlineSyntaxNode):
    '''The reference image syntax.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept of the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_label(self) -> str:
        '''Defines the interface for get label.
        
        :returns: The string label.'''
        ...
    
    def get_alt_text(self) -> str:
        '''Defines the interface for get of the alternate text.
        
        :returns: The alternate text.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class ReferenceLinkSyntaxNode(InlineSyntaxNode):
    '''Represent the reference link syntax.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept of the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_label(self) -> aspose.html.toolkit.markdown.syntax.InlineContainerSyntaxNode:
        '''Defines the interface for get label.
        
        :returns: The InlineContainer syntax.'''
        ...
    
    def get_content(self) -> aspose.html.toolkit.markdown.syntax.InlineContainerSyntaxNode:
        '''Defines the interface for get content.
        
        :returns: The InlineContainer syntax.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class SetextHeadingSyntaxNode(LeafBlockSyntaxNode):
    '''Represent the Setext heading syntax node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept of the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def level(self) -> int:
        '''Get the level of current syntax.'''
        ...
    
    ...

class SoftBreakSyntaxNode(LineBreakSyntaxNode):
    '''Represent the soft breaking syntax.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept of the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def source(self) -> aspose.html.toolkit.markdown.syntax.text.SourceText:
        '''Get the source.'''
        ...
    
    @property
    def span(self) -> aspose.html.toolkit.markdown.syntax.text.TextSpan:
        '''Get the span.'''
        ...
    
    @property
    def value(self) -> str:
        '''Get the value.'''
        ...
    
    ...

class TableCellSyntaxNode(LeafBlockSyntaxNode):
    '''Represent the table cell syntax node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_value(self) -> str:
        '''Defines the interface for get string value.
        
        :returns: The string value.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class TableDelimiterSyntaxNode(LeafBlockSyntaxNode):
    '''Represent the table delimiter syntax node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class TableRowSyntaxNode(LeafBlockSyntaxNode):
    '''The table row syntax node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def get_cells(self) -> Iterable[aspose.html.toolkit.markdown.syntax.TableCellSyntaxNode]:
        '''Defines the interface for get cells.
        
        :returns: The sequence of the cells.'''
        ...
    
    def append_cell(self, cell : aspose.html.toolkit.markdown.syntax.TableCellSyntaxNode) -> aspose.html.toolkit.markdown.syntax.TableCellSyntaxNode:
        '''Defines the interface for append of the cell.
        
        :param cell: The TableCellSyntax.
        :returns: The table syntax.'''
        ...
    
    def append_delimiter(self, delimiter : aspose.html.toolkit.markdown.syntax.TableDelimiterSyntaxNode) -> aspose.html.toolkit.markdown.syntax.TableDelimiterSyntaxNode:
        '''Defines the interface for append delimiter.
        
        :param delimiter: The delimiter.
        :returns: The table delimiter syntax.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class TableSyntaxNode(LeafBlockSyntaxNode):
    '''The TableSyntax class node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept of the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def append_row(self, row : aspose.html.toolkit.markdown.syntax.TableRowSyntaxNode) -> aspose.html.toolkit.markdown.syntax.TableRowSyntaxNode:
        '''Defines the interface for append row.
        
        :param row: The TableRowSyntax.
        :returns: The table syntax.'''
        ...
    
    def get_header(self) -> aspose.html.toolkit.markdown.syntax.TableRowSyntaxNode:
        '''Defines the interface for get table header.
        
        :returns: The table header.'''
        ...
    
    def get_body_rows(self) -> Iterable[aspose.html.toolkit.markdown.syntax.TableRowSyntaxNode]:
        '''Defines the interface for get body rows.
        
        :returns: The body rows.'''
        ...
    
    def get_alignment(self) -> Iterable[str]:
        '''Defines the interface for get aligment.
        
        :returns: The sequence of string.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class TaskListItemMarker(MarkdownSyntaxNode):
    '''The task list item marker.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Accept the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def is_checked(self) -> bool:
        '''Defines the interface for get checked status.
        
        :returns: The boolean.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class TaskListItemSyntaxNode(ListItemSyntaxNode):
    '''The task list item syntax node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def is_tight(self) -> bool:
        '''Get true if is tight.
        
        :returns: the boolean.'''
        ...
    
    def get_marker(self) -> aspose.html.toolkit.markdown.syntax.ListItemMarker:
        '''Get marker
        
        :returns: The ListItemMarker.'''
        ...
    
    def is_checked(self) -> bool:
        '''Defines the interface for get checked status.
        
        :returns: The boolean.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class TextSyntaxNode(InlineSyntaxNode):
    '''Implemented the text syntax node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for accept visitor.
        
        :param visitor: The MarkdownSyntaxVisitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def source(self) -> aspose.html.toolkit.markdown.syntax.text.SourceText:
        '''Return the source text.'''
        ...
    
    @property
    def span(self) -> aspose.html.toolkit.markdown.syntax.text.TextSpan:
        '''Defines the interface for get span.'''
        ...
    
    @property
    def value(self) -> str:
        '''Defines the property for get string value.'''
        ...
    
    ...

class ThematicBreakSyntaxNode(LeafBlockSyntaxNode):
    '''Imlemented the Thematic Break Syntax Node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for Accept visitor.
        
        :param visitor: The MarkdownSyntaxVisitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class Traversal:
    '''The abstract class Traversal'''
    
    @property
    def root(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get Root node.'''
        ...
    
    @property
    def filter(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNodeFilter:
        '''Defines the interface for get Filter.'''
        ...
    
    ...

class TreeWalker(Traversal):
    '''A tree walker.'''
    
    def parent_node(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get parent node.
        
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get first child node.
        
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get last child node.
        
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get previous sibling node.
        
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get next sibling node.
        
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def previous_node(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get previous node.
        
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def next_node(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get next node.
        
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    @property
    def root(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Defines the interface for get Root node.'''
        ...
    
    @property
    def filter(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNodeFilter:
        '''Defines the interface for get Filter.'''
        ...
    
    @property
    def current_node(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @current_node.setter
    def current_node(self, value : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode):
        ...
    
    ...

class TriviaCollection(IWritable):
    '''A collection of trivia.'''
    
    def get(self, index : int) -> aspose.html.toolkit.markdown.syntax.WhitespaceSyntaxNode:
        ...
    
    ...

class UnorderedListItemMarker(ListItemMarker):
    '''Represent the unordered list item syntax.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Accept the visitor.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class UnorderedListSyntaxNode(ListSyntaxNode):
    '''Represent the unordered list syntax node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for visiting nodes of the syntax.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    def is_tight(self) -> bool:
        '''Defines the interface for get is tight.
        
        :returns: The boolean value.'''
        ...
    
    def get_marker(self) -> str:
        '''Defines the interface to get of the marker.
        
        :returns: The string value.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    ...

class WhitespaceSyntaxNode(TextSyntaxNode):
    '''Represent the whitespace syntax node.'''
    
    def get_syntax_tree(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxTree:
        '''Get the syntax tree.
        
        :returns: The MarkdownSyntaxTree.'''
        ...
    
    def child_nodes(self) -> aspose.html.collections.NodeList:
        '''Get the child nodes collection.
        
        :returns: The NodeList.'''
        ...
    
    def get_leading_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the leading trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def get_trailing_trivia(self) -> aspose.html.toolkit.markdown.syntax.TriviaCollection:
        '''Get the Trailing trivia.
        
        :returns: The TriviaCollection.'''
        ...
    
    def append_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Append child node.
        
        :param node: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def remove_child(self, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Remove the child.
        
        :param child: The child.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def replace_child(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Replace the child node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def insert_before(self, node : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode, child : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Insert before node.
        
        :param node: The MarkdownSyntaxNode.
        :param child: The MarkdownSyntaxNode.
        :returns: The MarkdownSyntaxNode.'''
        ...
    
    def accept(self, visitor : aspose.html.toolkit.markdown.syntax.MarkdownSyntaxVisitor):
        '''Defines the interface for visiting nodes of the syntax.
        
        :param visitor: The visitor.'''
        ...
    
    def write_to(self, writer : aspose.html.toolkit.markdown.syntax.MarkdownTextWriter):
        '''Write to MarkdownTextWriter.
        
        :param writer: The MarkdownTextWriter.'''
        ...
    
    @property
    def parent(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        '''Get the parent node.'''
        ...
    
    @property
    def first_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def last_child(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def previous_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def next_sibling(self) -> aspose.html.toolkit.markdown.syntax.MarkdownSyntaxNode:
        ...
    
    @property
    def source(self) -> aspose.html.toolkit.markdown.syntax.text.SourceText:
        '''Return the source text.'''
        ...
    
    @property
    def span(self) -> aspose.html.toolkit.markdown.syntax.text.TextSpan:
        '''Defines the interface for get span.'''
        ...
    
    @property
    def value(self) -> str:
        '''Defines the property for get string value.'''
        ...
    
    ...

class Emphasis:
    '''Represents the Emphasis.'''
    
    @classmethod
    @property
    def UNDEFINED(cls) -> Emphasis:
        '''The Undefined value.'''
        ...
    
    @classmethod
    @property
    def STRONG(cls) -> Emphasis:
        '''The Strong value.'''
        ...
    
    @classmethod
    @property
    def REGULAR(cls) -> Emphasis:
        '''The Regular value.'''
        ...
    
    @classmethod
    @property
    def STRIKE_THROUGH(cls) -> Emphasis:
        '''The StrikeThrough value.'''
        ...
    
    ...

